abstract class Expression
case class C(n: Int)    extends Expression // constant
case class V(s: String) extends Expression // variable
case class Plus(e1: Expression, e2: Expression) extends Expression
case class Times(e1: Expression, e2: Expression) extends Expression

abstract class Statement
case class Assign(id:String, e:Expression) extends Statement
case class Block(s: List[Statement])       extends Statement

val program = Assign("res", Plus(C(14), Times(V("arg"),C(3))))