sealed abstract class List[A] { // A is the alphabet 
  def ::(t:A): List[A] = Cons(t, this)
  def length: BigInt = this match {
    case Nil() => BigInt(0)
    case Cons(h, t) => 1 + t.length  }
  def apply(index: BigInt): A = {
    this match {
      case Cons(h,t) =>
        if (index == BigInt(0)) h
        else t(index-1) } }
}
case class Nil[A]() extends List[A]
case class Cons[A](h: A, t: List[A]) extends List[A] 

val w = 1 :: 0 :: 1 :: 1 :: Nil[Int]()   //  1011
val n = w.length // 4
val z = w(1) // 0