def slice(i: BigInt, j: BigInt): List[T] = {
  require(0 <= i && i <= j &&  j <= length)
  this match {
    case Nil() => Nil()
    case Cons(h,t) =>
      if (i == 0 && j == 0) Nil()
      else if (i == 0) Cons(h, t.slice(0, j-1))
      else t.slice(i-1, j-1)
  }
} ensuring(_.size == j - i)
